require 'yaml'

module DbObfuscation
  module Cli
    module DbDump
      def self.dump(config_file, dump_name)
        config = db_config(config_file)
        Kernel.system cmd(config, dump_name)
      end

      def self.db_config(file)
        YAML.load_file(file)
      end
      private_class_method :db_config

      def self.cmd(config, dump_name)
        <<-CMD.gsub(/\s{2,}/,' ').strip
        PGPASSWORD=#{config['password']}
        pg_dump
        -h #{config['host']}
        -U #{config['username']} -w
        -Fc -f #{dump_name}
        #{config['database']}
        CMD
      end
      private_class_method :cmd
    end
  end
end
