require 'yaml'

module DbObfuscation
  module Cli
    class Migrator
      def self.migrate(config_file, path_to_migrations)
        config = db_config(config_file)

        db_name = "postgres://#{config['host']}/#{config['database']}"
        system("sequel -m #{path_to_migrations} #{db_name}")
      end

      def self.down_migrate(config_file, path_to_migrations)
        config = db_config(config_file)

        db_name = "postgres://#{config['host']}/#{config['database']}"
        system("sequel -m #{path_to_migrations} -M 0 #{db_name}")
      end

      def self.db_config(config_file)
        YAML.load_file(config_file)
      end
      private_class_method :db_config
    end
  end
end
