require 'db_obfuscation/database'
require 'db_obfuscation/obfuscator'

module DbObfuscation
  class BatchFormulator

    def self.batch_for(*args)
      self.new.batch_for(*args)
    end

    def batch_for(config, ids)
      ids.each_with_object([]) do |id, batch|
        batch<<obfuscate_row(config, id)
      end
    end

    private

    def obfuscate_row(config, id)
      config.each_with_object({}) do |(column, strategy), obfuscated_hash|
        value = Obfuscator.obfuscate(strategy)
        obfuscated_hash[column] = DB.literal value
      end.merge(id: id)
    end
  end
end
