require 'db_obfuscation/database'

module DbObfuscation
  module Filtering
    module Column
      class << self
        def columns_type(table_name)
          column_types = {}
          columns(table_name).each do |column_name, column_details|
            column_types[column_name] = column_details[:type]
          end
          column_types
        end

        def columns(table_name)
          DbObfuscation::DB.schema(table_name)
        end

        def type?(expected_column_types, column_type)
          expected_column_types.include? column_type
        end

        def polymorphic?(column_name)
          column_name.match(/type$/) ? true : false
        end

        def ending_in_id?(column_name)
          column_name.match(/id$/) ? true : false
        end

        def filter(column_name, column_type, expected_types)
          return nil if polymorphic?(column_name)
          return nil if ending_in_id?(column_name)
          return nil unless type?(expected_types, column_type)
          return column_name
        end
      end
    end
  end
end
