require 'db_obfuscation/database'
require 'db_obfuscation/filtering/truncation'

module DbObfuscation
  class Truncation


    def self.truncate
      new.send(:truncate)
    end

    def self.tables
      new.send(:tables)
    end

    private

    def truncate
      tables.each do |table|
        begin
          DbObfuscation.logging.info "Truncating #{table}"
          DB[table].truncate
        rescue => e
          DbObfuscation.logging.error "#{table} encountered #{e.message}"
          DbObfuscation.logging.error "#{e.backtrace}"
        end

      end
    end

    def tables
      Filtering::Truncation.matches_patterns(DB.tables, patterns)
    end

    def patterns
      Config.truncation_patterns
    end
  end
end
